#include <stdio.h>
#include <tos.h>
#include <ext.h>

typedef unsigned char BYTE;
typedef unsigned int  WORD;
typedef unsigned long LONG;

#define HALFTONE(x) (*((volatile WORD *)0xFF8A00L+(x<<1)))
#define OP 			(*((volatile BYTE *)0xFF8A3BL))
#define ENDMASK1	(*((volatile WORD *)0xFF8A28L))
#define ENDMASK2	(*((volatile WORD *)0xFF8A2AL))
#define ENDMASK3	(*((volatile WORD *)0xFF8A2CL))
#define X_COUNT		(*((volatile WORD *)0xFF8A36L))
#define Y_COUNT		(*((volatile WORD *)0xFF8A38L))
#define DST_XINC	(*((volatile WORD *)0xFF8A2EL))
#define DST_YINC	(*((volatile WORD *)0xFF8A30L))
#define DST_ADDR	(*((volatile LONG *)0xFF8A32L))
#define SRC_XINC	(*((volatile WORD *)0xFF8A20L))
#define SRC_YINC	(*((volatile WORD *)0xFF8A22L))
#define SRC_ADDR	(*((volatile LONG *)0xFF8A24L))
#define HOP			(*((volatile BYTE *)0xFF8A3AL))
#define LINE_NUM	(*((volatile BYTE *)0xFF8A3CL))
#define SKEW		(*((volatile BYTE *)0xFF8A3DL))

WORD srcbuf[64];
WORD dstbuf[32] = {0};

long do_copy(void) {
	OP = 7; /* D = S or D */
	
	ENDMASK1 = ENDMASK2 = ENDMASK3 = 0xFFFF;
	
	X_COUNT = 1;
	Y_COUNT = 32;
	
	DST_XINC = -2;
	DST_YINC = -2;
	DST_ADDR = (LONG)(&dstbuf[31]);

	SRC_XINC = -2;
	SRC_YINC = -2;
	SRC_ADDR = (LONG)(&srcbuf[63]);
	
	HOP = 2; /* use source data */
	
	LINE_NUM = 0;
	SKEW = (1<<7) + (1<<6); /* FXSR NFSR */
	
	LINE_NUM = 0x80; /* set busy bit: start blitter: no HOG mode */
	while (LINE_NUM & 0x80)
		continue;
	
	return 0;
}


int main(void) {
	unsigned int i;
	
	for (i=0; i<64; i++) {
		srcbuf[i] = i;
	}
	
	Supexec(do_copy);
	
	for (i=0; i<32; i++) {
		printf("%d ", dstbuf[i]);
		if (i==15)
			printf("\r\n");
	}
				 
	getch();
	
	return 0;
}